/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package test;

import com.sun.grizzly.Controller;
import com.sun.grizzly.DefaultProtocolChain;
import com.sun.grizzly.DefaultProtocolChainInstanceHandler;
import com.sun.grizzly.ProtocolChain;
import com.sun.grizzly.ProtocolChainInstanceHandler;
import com.sun.grizzly.TCPSelectorHandler;
import com.sun.grizzly.filter.ReadFilter;
import com.sun.grizzly.util.PipelineThreadPool;
import java.io.IOException;
import java.net.InetAddress;
import java.util.concurrent.ExecutorService;

/**
 *
 * @author oleksiys
 */
public class SelectorHandlerFilter {

    public static void main(String[] args) throws Exception {
        Controller controller = new Controller();

        // Add the admin handler
        final DefaultMessageFilter defaultMessageFilter = new DefaultMessageFilter();

        final ProtocolChain protocolDefaultChain = new DefaultProtocolChain();
        protocolDefaultChain.addFilter(new ReadFilter());
        protocolDefaultChain.addFilter(defaultMessageFilter);

        ((DefaultProtocolChain) protocolDefaultChain).setContinuousExecution(false);

        ProtocolChainInstanceHandler pciDefaultHandler = new DefaultProtocolChainInstanceHandler() {

            public ProtocolChain poll() {
                return protocolDefaultChain;
            }

            public boolean offer(ProtocolChain protocolAdminChain) {
                return false;
            }
        };

        controller.setProtocolChainInstanceHandler(pciDefaultHandler);

        // Add the admin handler
        final AdminMessageFilter adminMessageFilter = new AdminMessageFilter();

        final ProtocolChain protocolAdminChain = new DefaultProtocolChain();
        protocolAdminChain.addFilter(new ReadFilter());
        protocolAdminChain.addFilter(adminMessageFilter);

        ((DefaultProtocolChain) protocolAdminChain).setContinuousExecution(false);

        ProtocolChainInstanceHandler pciAdminHandler = new DefaultProtocolChainInstanceHandler() {

            public ProtocolChain poll() {
                return protocolAdminChain;
            }

            public boolean offer(ProtocolChain protocolAdminChain) {
                return false;
            }
        };

        final RegularMessageFilter regularMessageFilter = new RegularMessageFilter();

        final ProtocolChain protocolRegularChain = new DefaultProtocolChain();
        protocolRegularChain.addFilter(new ReadFilter());
        protocolRegularChain.addFilter(regularMessageFilter);

        ((DefaultProtocolChain) protocolRegularChain).setContinuousExecution(false);

        ProtocolChainInstanceHandler pciRegularHandler = new DefaultProtocolChainInstanceHandler() {

            public ProtocolChain poll() {
                return protocolRegularChain;
            }

            public boolean offer(ProtocolChain protocolAdminChain) {
                return false;
            }
        };


        TCPSelectorHandler tcpAdminHandler = new TCPSelectorHandler();
        tcpAdminHandler.setInet(InetAddress.getByName("127.0.0.1"));
        tcpAdminHandler.setPort(7000);
        // This doesn't seem to work.
        tcpAdminHandler.setProtocolChainInstanceHandler(pciAdminHandler);



        TCPSelectorHandler tcpRegularHandler = new TCPSelectorHandler();
        tcpRegularHandler.setInet(InetAddress.getByName("127.0.0.1"));
        tcpRegularHandler.setPort(7001);
        // This doesn't seem to work.
        tcpRegularHandler.setProtocolChainInstanceHandler(pciRegularHandler);

        TCPSelectorHandler tcpDefaultHandler = new TCPSelectorHandler();
        tcpDefaultHandler.setInet(InetAddress.getByName("127.0.0.1"));
        tcpDefaultHandler.setPort(7002);


        controller.addSelectorHandler(tcpAdminHandler);
        controller.addSelectorHandler(tcpRegularHandler);
        controller.addSelectorHandler(tcpDefaultHandler);


        ExecutorService threadPool = new PipelineThreadPool();
        controller.setThreadPool(threadPool);


        try {
            System.out.println("Start...");
            controller.start();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
